-----------------------------------------------------------------------------------------------------
-- Inicio Script 10 Abril 2015 Oscar Garcia 	                                                   --
-- Ajuste para el menu de Parametrizacion                                                          --
-----------------------------------------------------------------------------------------------------

CREATE TABLE [dbo].[RecursosExternos](
	[idRecurso] [int] IDENTITY(1,1) NOT NULL,
	[idEmpresa] [int] NOT NULL,
	[Descripcion] [varchar](250) NOT NULL,
	[Url] [varchar](500) NULL,
	[Habilitado] [int] NULL,
 CONSTRAINT [PK_RecursosExternos] PRIMARY KEY CLUSTERED 
(
	[idRecurso] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

DECLARE @idEmpresa INT
select @idEmpresa = idEmpresa from Empresa where idEmpresa != 1
insert into RecursosExternos values (@idEmpresa, 'URL que redirige hacia aplicacin externa de directorio activo para recordar contrasea', 'http://srvoim:7777/customOimWar/resetPass.xhtml', '0')
insert into RecursosExternos values (@idEmpresa, 'URL que redirige hacia aplicacin externa de la empresa y que muestra informacin til', 'http://business.policia.gov.co:9704/analytics/saw.dll?Dashboard&NQUser=consulta_arcoi', '0')
insert into RecursosExternos values (@idEmpresa, 'Ruta alterna en la que se van a guardar las Referencias a Papeles de Trabajo', '\\Srvpncfiles\AUDIRISK\inetpub\wwwroot\AudiRisk\RefPapeles\', '0');


insert into Menu values ('0403020109', 'Recursos Externos', '~/Configuracion/ListarRecursosExternos.aspx', '0')
insert into MenuPerfil values ('0403020109', '14')
insert into MenuPerfil values ('0403020109', '16')
insert into MenuPerfil values ('0403020109', '18')
insert into MenuPerfil values ('0403020109', '19')

update Menu set descripcion = 'Configuracin de Moneda',  enlace = '~/Configuracion/ListarMonedas.aspx' where idMenu = '0403020206'
update Menu set descripcion = 'Activos Impactados',  enlace = '~/Configuracion/ListarActivosImpactados.aspx' where idMenu = '0403020207'
update Menu set descripcion = 'Agentes Generadores',  enlace = '~/Configuracion/ListarAgenteGenerador.aspx' where idMenu = '0403020208'
update Menu set descripcion = 'Vulnerabilidades',  enlace = '~/Configuracion/ListarVulnerabilidades.aspx' where idMenu = '0403020209'
update Menu set descripcion = 'Frecuencias de Ejecucin de Controles',  enlace = '~/Configuracion/ListarFrecuenciaEjecucionControl.aspx' where idMenu = '0403020210'
update Menu set descripcion = 'Frecuencias de ocurrencia de la amenaza',  enlace = '~/Configuracion/ListarFrecuenciaAmenaza.aspx' where idMenu = '0403020211'
update Menu set descripcion = 'Tipos de Impacto',  enlace = '~/Configuracion/SeleccionarTipoImpacto.aspx' where idMenu = '0403020212'
update Menu set descripcion = 'Caractersticas de la Informacin de Negocios',  enlace = '~/audConfiguracion/ListarCriterioCobit.aspx' where idMenu = '0403020213'
insert into menu values ('0403020214', 'Tecnicas de Auditoria', '~/audConfiguracion/TecnicaAuditoria.aspx', '0')

--insert into ProbabilidadEmpresa values ('1', '8', '156')
--insert into FrecuenciaOcurrenciaEmpresa values ('1', '193', '30.000000', '8')



CREATE TABLE [dbo].[ClaseAuditoria](
	[idClaseAuditoria] [int] IDENTITY(1,1) NOT NULL,
	[nombreClase] [varchar](250) NOT NULL,
	[Descripcion] [varchar](3000) NOT NULL,
 CONSTRAINT [PK_idClaseAuditoria] PRIMARY KEY CLUSTERED 
(
	[idClaseAuditoria] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

insert into ClaseAuditoria Values ('Integral', 'La auditora integral consiste en la verificacin realizada a la empresa en todos los procesos y procedimientos que en esta se realizan')
insert into ClaseAuditoria Values ('Especifica', 'La auditora especfica consiste en la verificacin realizada en uno o varios escenarios de un proceso, procedimiento y/o actividad determinada, la cual solo podr ser ordenada por el Gerente o Subgerente de la empresa')
insert into ClaseAuditoria Values ('Calidad', 'La auditora de calidad, se define como un Proceso sistemtico, independiente y documentado  para obtener evidencias de la auditora (registros, declaraciones de hechos o cualquier  otra informacin) y evaluarlas de manera objetiva, esta permite determinar la conformidad del Sistema de Gestin de la Calidad con los requisitos establecidos en la norma de calidad y as mismo verificar la implementacin y mantenimiento del Sistema de Gestin Integral')
insert into ClaseAuditoria Values ('Combinada', 'La auditora combinada consiste en auditar los Sistemas de Gestin de Calidad y el Medioambiente')
insert into ClaseAuditoria Values ('Seguimiento', 'La auditora de seguimiento consiste en la verificacin realizada al proceso y/o actividades de un proceso respecto de los planes de mejoramiento')

ALTER TABLE [Estudio]
	ADD [idClaseAuditoria] [int] NULL
GO



SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

SET ANSI_PADDING ON
GO

CREATE TABLE [dbo].[ClaseHallazgo](
	[idClaseHallazgo] [int] IDENTITY(1,1) NOT NULL,
	[Descripcion] [varchar](250) NOT NULL,
	[Detalle] [varchar](3000) NULL,
 CONSTRAINT [PK_ClaseHallazgo] PRIMARY KEY CLUSTERED 
(
	[idClaseHallazgo] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

CREATE TABLE [dbo].[NivelHallazgo](
	[idNivelHallazgo] [int] IDENTITY(1,1) NOT NULL,
	[Descripcion] [varchar](250) NOT NULL,
	[Detalle] [varchar](3000) NULL,
 CONSTRAINT [PK_NivelHallazgo] PRIMARY KEY CLUSTERED 
(
	[idNivelHallazgo] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

SET ANSI_PADDING OFF
GO

insert into NivelHallazgo values ('Estrategico', 'Son aquellos hallazgos evidenciados en un proceso, como resultado de una auditora, cuya responsabilidad y competencia para subsanarlos, recae en los dueos de procesos')
insert into NivelHallazgo values ('Tactico', 'Son aquellos hallazgos cuya responsabilidad y competencia para subsanarlos recae en los dueos de procesos')
insert into NivelHallazgo values ('Operacional', 'Son aquellos hallazgos evidenciados en la auditora, relacionados directamente con la ejecucin de cualquier proceso o actividad, comprendida dentro del Sistema de Gestin Integral de la empresa')

insert into ClaseHallazgo values ('Administrativo', 'Por definicin un hallazgo administrativo es un hecho que demuestra que la gestin fiscal de un sujeto de control no se est desarrollando de acuerdo a los principios generales establecidos')
insert into ClaseHallazgo values ('Disciplinario', 'Hallazgo administrativo donde se configura que los servidores pblicos o los particulares que transitoriamente ejerzan funciones pblicas, han incurrido en alguna violacin a las normas disciplinarias')
insert into ClaseHallazgo values ('Fiscal', 'Son situaciones donde se observa un mal uso de los recursos asignados para el cumplimiento de la funcin administrativa y conlleva a un detrimento del patrimonio pblico')
insert into ClaseHallazgo values ('Penal', 'Son situaciones donde se evidencia que en el ejercicio de sus funciones administrativas, se est cometiendo una accin tipificada como delito en el cdigo penal')
insert into ClaseHallazgo values ('Otro', 'Otro')

------------------------------------------------------------------------------------------
-- Fin Script 10 Abril 2015 Oscar Garcia	                  	                        --
------------------------------------------------------------------------------------------


-----------------------------------------------------------------------------------------------------
-- Inicio Script 10 Abril 2015 Oscar Garcia 	                                                   --
-- Ajuste para ingresar nuevos campos en Hallazgos de Auditorias                                   --
-----------------------------------------------------------------------------------------------------

ALTER TABLE HallazgosAuditoria
	ADD [idNivelHallazgo] [int] NULL,
		[CodigoInterno] [varchar](300) NULL,
		[idClaseHallazgo] [int] NULL
GO

ALTER TABLE dbo.ReferenciasHallazgosAuditoria
	ADD ruta varchar(500) NULL
GO



insert into Menu values ('0403020110', 'Clases de Auditoria', '~/Configuracion/ListarClasesAuditoria.aspx', '0')
insert into Menu values ('0403020111', 'Clases de Hallazgo', '~/Configuracion/ListarClasesHallazgo.aspx', '0')
insert into Menu values ('0403020112', 'Niveles de Hallazgo', '~/Configuracion/ListarNivelesHallazgo.aspx', '0')
insert into MenuPerfil values ('0403020110', '14')
insert into MenuPerfil values ('0403020110', '16')
insert into MenuPerfil values ('0403020110', '18')
insert into MenuPerfil values ('0403020110', '19')
insert into MenuPerfil values ('0403020111', '14')
insert into MenuPerfil values ('0403020111', '16')
insert into MenuPerfil values ('0403020111', '18')
insert into MenuPerfil values ('0403020111', '19')
insert into MenuPerfil values ('0403020112', '14')
insert into MenuPerfil values ('0403020112', '16')
insert into MenuPerfil values ('0403020112', '18')
insert into MenuPerfil values ('0403020112', '19')

------------------------------------------------------------------------------------------
-- Fin Script 10 Abril 2015 Oscar Garcia	                  	                        --
------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------
-- Inicio Script 10 Abril 2015 Oscar Garcia 	                                                   --
-- Ajuste para Documentacion de Amenazas                                                           --
-----------------------------------------------------------------------------------------------------

ALTER TABLE EstudioAmenaza
	ADD [idArea] [int] NULL,
		[idCargo] [int] NULL
GO

ALTER TABLE ReferenciaPapelTrabajo
	ADD ruta varchar(500) NULL
GO

------------------------------------------------------------------------------------------
-- Fin Script 10 Abril 2015 Oscar Garcia	                  	                        --
------------------------------------------------------------------------------------------


-----------------------------------------------------------------------------------------------------
-- Inicio Script 10 Abril 2015 Oscar Garcia 	                                                   --
-- Ajuste para Implementacin de nuevo menu en Planeacion de Auditoria                             --
-----------------------------------------------------------------------------------------------------

UPDATE Menu
	SET descripcion = 'Seleccionar Procesos Trabajos para el Plan Anual - Tipo Auditoria'
	WHERE idMenu = '0402020301'

UPDATE Menu
	SET descripcion = 'Definir Auditorias por Proceso o Sistema', enlace = '~/audPlaneacionAuditoria/DefinirAuditoriasProceso.aspx'
	WHERE idMenu = '0402020302'

UPDATE Menu
	SET descripcion = 'Programar Auditorias a Realizar - Proceso', enlace = '~/audPlaneacionAuditoria/ListarTrabajosCronogramaNuevo.aspx'
	WHERE idMenu = '0402020303'

INSERT INTO Menu values ('0402020304', 'Generar Plan Anual Auditorias a Realizar - Proceso', '~/audPlaneacionAuditoria/GenerarPlan.aspx', '1')

CREATE TABLE [dbo].[AuditoriasPorProceso](
	[idProcesoAuditoria] [int] IDENTITY(1,1) NOT NULL,
	[idTrabajoAuditoria] [int] NOT NULL,
	[idAuditoriaRealizar] [int] NOT NULL,
	[fechaInicio] [datetime] NULL,
	[fechaFin] [datetime] NULL,
	[duracionEstimada] [numeric](10, 2) NULL,
	[alcance] [varchar](700) NULL,
	[cantidadAuditores] [int] NULL,
	[horasDiariasLab] [numeric](10, 2) NULL,
	[diasFeriados] [int] NULL,
	[duracionDias] [int] NULL,
	[duracionSemana] [numeric](5, 2) NULL,
	[otrosGastos] [numeric](18, 2) NULL,
	[horasSupervisor] [numeric](5, 2) NULL,
	[horasAuditor] [numeric](5, 2) NULL,
	[diasCalendario] [int] NULL,
	[fechaFinConFeriados] [datetime] NULL,
	[annoFiscal] [int] NULL,
	[idEmpresaAuditora] [int] NULL,
	[terminado] [int] NULL,
 CONSTRAINT [PK_AuditoriasPorProceso] PRIMARY KEY CLUSTERED 
(
	[idProcesoAuditoria] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

CREATE TABLE [dbo].[NombresAuditoriaRealizar](
	[idAuditoriaRealizar] [int] IDENTITY(1,1) NOT NULL,
	[nombreAuditoriaRealizar] [varchar](255) NOT NULL,
	[descripcionAuditoria] [varchar](200) NULL,
 CONSTRAINT [PK_NombresAuditoriaRealizar] PRIMARY KEY CLUSTERED 
(
	[idAuditoriaRealizar] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

INSERT INTO NombresAuditoriaRealizar VALUES ('Auditora del Control interno', 'Auditora del Control interno para pruebas')
INSERT INTO NombresAuditoriaRealizar VALUES ('Seguimiento a informe de Control Interno', 'Seguimiento a informe de Control Interno')
INSERT INTO NombresAuditoriaRealizar VALUES ('Seguimiento a informe de Pruebas de Auditora', 'Seguimiento a informe de Pruebas de Auditora')

CREATE TABLE [dbo].[ResponsableAuditoriaPorProceso](
	[idProcesoAuditoria] [int] NOT NULL,
	[idResponsableAuditoriaPorProceso] [int] IDENTITY(1,1) NOT NULL,
	[nombreResponsable] [varchar](200) NOT NULL,
	[idCargo] [int] NULL,
	[idResponsabilidad] [int] NULL,
	[vlHora] [numeric](18, 0) NULL,
	[NoHoras] [int] NULL,
	[annoFiscal] [int] NOT NULL,
	[idEmpresa] [int] NOT NULL,
 CONSTRAINT [PK_ResponsableAuditoriaPorProceso] PRIMARY KEY CLUSTERED 
(
	[idResponsableAuditoriaPorProceso] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

SET ANSI_PADDING OFF
GO

ALTER TABLE [dbo].[ResponsableAuditoriaPorProceso]  WITH CHECK ADD  CONSTRAINT [FK_ResponsableAuditoriaPorProceso_AuditoriasPorProceso] FOREIGN KEY([idProcesoAuditoria])
REFERENCES [dbo].[AuditoriasPorProceso] ([idProcesoAuditoria])
GO

ALTER TABLE [dbo].[ResponsableAuditoriaPorProceso] CHECK CONSTRAINT [FK_ResponsableAuditoriaPorProceso_AuditoriasPorProceso]
GO

ALTER TABLE [dbo].[ResponsableAuditoriaPorProceso]  WITH CHECK ADD  CONSTRAINT [FK_ResponsableAuditoriaPorProceso_CargosNivelesAuditorPlaneacion] FOREIGN KEY([idCargo])
REFERENCES [dbo].[CargosNivelesAuditorPlaneacion] ([idCargoNivel])
GO

ALTER TABLE [dbo].[ResponsableAuditoriaPorProceso] CHECK CONSTRAINT [FK_ResponsableAuditoriaPorProceso_CargosNivelesAuditorPlaneacion]
GO

ALTER TABLE [dbo].[ResponsableAuditoriaPorProceso]  WITH CHECK ADD  CONSTRAINT [FK_ResponsableAuditoriaPorProceso_NivelesAuditorPlaneacion] FOREIGN KEY([idResponsabilidad])
REFERENCES [dbo].[NivelesAuditorPlaneacion] ([idNivel])
GO

ALTER TABLE [dbo].[ResponsableAuditoriaPorProceso] CHECK CONSTRAINT [FK_ResponsableAuditoriaPorProceso_NivelesAuditorPlaneacion]
GO

CREATE TABLE [dbo].[OtrosGastosAuditoriasPorProceso](
	[idConcepto] [int] IDENTITY(1,1) NOT NULL,
	[NombreConcepto] [varchar](150) NOT NULL,
	[DescripcionConcepto] [varchar](150) NOT NULL,
	[costoUnitario] [numeric](18, 2) NOT NULL,
	[costoTotal] [numeric](18, 2) NOT NULL,
	[Cantidad] [int] NOT NULL,
	[idEmpresa] [int] NOT NULL,
	[annoFiscal] [int] NOT NULL,
	[idProcesoAuditoria] [int] NULL,
 CONSTRAINT [PK_OtrosGastosAuditoriasPorProceso] PRIMARY KEY CLUSTERED 
(
	[idConcepto] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

ALTER TABLE [dbo].[OtrosGastosAuditoriasPorProceso]  WITH CHECK ADD  CONSTRAINT [FK_OtrosGastosAuditoriasPorProceso_AuditoriasPorProceso] FOREIGN KEY([idProcesoAuditoria])
REFERENCES [dbo].[AuditoriasPorProceso] ([idProcesoAuditoria])
GO

ALTER TABLE [dbo].[OtrosGastosAuditoriasPorProceso] CHECK CONSTRAINT [FK_OtrosGastosAuditoriasPorProceso_AuditoriasPorProceso]
GO


CREATE TABLE [dbo].[SeguimientoAuditoriasPorProceso](
	[idSeguimiento] [int] IDENTITY(1,1) NOT NULL,
	[idProcesoAuditoria] [int] NOT NULL,
	[fechaseguimiento] [datetime] NOT NULL,
	[porcentajeAvance] [int] NOT NULL,
	[descripcionAvance] [varchar](3000) NOT NULL,
	[comentarios] [varchar](3000) NOT NULL,
	[idSupervisor] [int] NOT NULL,
	[Estado] [char](1) NOT NULL,
	[idEmpresa] [int] NULL,
	[annoFiscal] [int] NULL,
 CONSTRAINT [PK_seguimientoAuditoriasPorProceso] PRIMARY KEY CLUSTERED 
(
	[idSeguimiento] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

ALTER TABLE [dbo].[SeguimientoAuditoriasPorProceso]  WITH CHECK ADD  CONSTRAINT [FK_seguimientoAuditoriasPorProceso_AuditoriasPorProceso] FOREIGN KEY([idProcesoAuditoria])
REFERENCES [dbo].[AuditoriasPorProceso] ([idProcesoAuditoria])
GO

ALTER TABLE [dbo].[SeguimientoAuditoriasPorProceso] CHECK CONSTRAINT [FK_seguimientoAuditoriasPorProceso_AuditoriasPorProceso]
GO

ALTER TABLE [dbo].[SeguimientoAuditoriasPorProceso]  WITH CHECK ADD  CONSTRAINT [FK_seguimientoAuditoriasPorProceso_usuario] FOREIGN KEY([idSupervisor])
REFERENCES [dbo].[Usuario] ([idUsuario])
GO

ALTER TABLE [dbo].[SeguimientoAuditoriasPorProceso] CHECK CONSTRAINT [FK_seguimientoAuditoriasPorProceso_usuario]
GO

ALTER TABLE [dbo].[SeguimientoAuditoriasPorProceso]  WITH CHECK ADD  CONSTRAINT [CK_seguimientoAuditoriasPorProcesoEstado] CHECK  (([Estado]='A' OR [Estado]='C' OR [Estado]='T' OR [Estado]='E' OR [Estado]='I'))
GO

ALTER TABLE [dbo].[SeguimientoAuditoriasPorProceso] CHECK CONSTRAINT [CK_seguimientoAuditoriasPorProcesoEstado]
GO

EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'''I'':Por iniciar, ''E'': En ejecucion, ''T'': Terminado, ''C'': Anulado o Cancelado ''A'':Aplazado' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'SeguimientoAuditoriasPorProceso', @level2type=N'CONSTRAINT',@level2name=N'CK_seguimientoAuditoriasPorProcesoEstado'
GO


INSERT INTO MenuEstadosPlaneacionAnualInternas VALUES ('0402020304', '1', '2011', 'P')
INSERT INTO Pagina VALUES ('Generar Plan Anual Auditorias a Realizar - Proceso', 'audPlaneacionAuditoria/GenerarPlan.aspx', '0', 'audPlaneacionAuditoria', '0402020304', NULL)

DECLARE @idPagina INT
SELECT @idPagina = idPagina FROM Pagina where nombre = 'Generar Plan Anual Auditorias a Realizar - Proceso'
INSERT INTO PaginaPerfil VALUES (@idPagina, '14')
INSERT INTO PaginaPerfil VALUES (@idPagina, '16')
INSERT INTO PaginaPerfil VALUES (@idPagina, '18')
INSERT INTO PaginaPerfil VALUES (@idPagina, '19')

--ALTER TABLE INT_AuditoriaEstudio
--	DROP CONSTRAINT FK_INT_AuditoriaEstudio_TrabajoAudCandidatoInternas1
	
--ALTER TABLE INT_AuditoriaEstudio
--	DROP CONSTRAINT FK_INT_AuditoriaEstudioTrabajoAuditoria


--ALTER TABLE INT_AuditoriaEstudio
--	ADD CONSTRAINT FK_INT_AuditoriaEstudio_AuditoriasPorProceso FOREIGN KEY (idTrabajo)
--    REFERENCES AuditoriasPorProceso(idProcesoAuditoria)

--ALTER TABLE INT_AuditoriaEstudio
--	ADD CONSTRAINT FK_INT_AuditoriaEstudio_TrabajoAuditoria FOREIGN KEY (idDetalle)
--    REFERENCES TrabajoAuditoria(idTrabajoAuditoria)
	
UPDATE menu
	SET descripcion = 'Identificar Amenazas por Categoria de Riesgo'
	where idMenu = '04040304'
	
ALTER TABLE NombresAuditoriaRealizar
	ADD idEmpresa Integer NULL
	GO

update NombresAuditoriaRealizar
	set idEmpresa = 1
	
------------------------------------------------------------------------------------------
-- Fin Script 10 Abril 2015 Oscar Garcia	                  	                        --
------------------------------------------------------------------------------------------
	
	
-------------------------------------------------------------------------------------------------------------------
-- Inicio Script 10 Abril 2015 Oscar Garcia 	                                                                 --
-- Nuevos procedimientos almacenados que permiten sincronizar informacin corporativa de la empresa con AudiRisk --
-------------------------------------------------------------------------------------------------------------------
	
CREATE PROCEDURE [dbo].[sp_SincronizarAreaOrganizacional] AS 

DECLARE		@idEmpresa				INT,
			@sigla  				VARCHAR(50),
			@descripcionDependencia VARCHAR(2500)
						
	BEGIN
	DECLARE	curAreasPONAL CURSOR LOCAL FOR
	--
	--  Sincronizacin de Unidades areas de la empresa hacia Areas Organizacionales de AudiRisk
	--	Extraer la informacin de la vista y asignarla directamente en la consulta OPENQUERY
	--
		SELECT	IDEMPRESA, DESCRIPCION_DEPENDENCIA, SIGLA
			FROM OPENQUERY(PONAL_VISTAS,'select * from USR_REHU.V_UNIDADES_AUDIRISK')
	
	OPEN curAreasPONAL
		FETCH NEXT FROM curAreasPONAL INTO @idEmpresa, @descripcionDependencia, @sigla
		WHILE @@FETCH_STATUS = 0 BEGIN
			BEGIN TRANSACTION
				IF NOT EXISTS (
				SELECT	*
					FROM	AreaOrganizacional
					WHERE	UPPER(LTRIM(RTRIM(descripcionArea))) = UPPER(LTRIM(RTRIM(@descripcionDependencia)))
					AND UPPER(LTRIM(RTRIM(nombreArea))) = UPPER(LTRIM(RTRIM(@sigla)))
				
				) BEGIN
					-- Insertado registro
					INSERT INTO	AreaOrganizacional (idEmpresa, nombreArea, descripcionArea, interna, codigo, tieneOficinas, idUsuario, idTipoArea)
						VALUES (@idEmpresa, @sigla, @descripcionDependencia, 1, NULL, 0, NULL, NULL)
				END
			COMMIT TRANSACTION
			FETCH NEXT FROM curAreasPONAL INTO @idEmpresa, @descripcionDependencia, @sigla
		END
END
GO


CREATE PROCEDURE [dbo].[sp_SincronizarCargo] AS

DECLARE		@idEmpresa			INT,
			@idArea				INT,
			@unidadPadre		VARCHAR(50),
			@nombreArea			VARCHAR(50),
			@nombreCargo		VARCHAR(50),
			@descripcionCargo	VARCHAR(2500)
						
	BEGIN
	DECLARE	curCargosPONAL CURSOR LOCAL FOR
	--
	--  Sincronizacin de Cargos de la empresa hacia Cargos de AudiRisk
	--	Extraer la informacin de la vista y asignarla directamente en la consulta OPENQUERY
	--
		SELECT	IDEMPRESA, UNIDAD_PADRE, NOMBRE_AREA, NOMBRE_CARGO, DESCRIPCION_CARGO
			FROM OPENQUERY(PONAL_VISTAS,'select * from USR_REHU.V_CARGOS_UNIDAD_AUDIRISK')
	
	OPEN curCargosPONAL
		FETCH NEXT FROM curCargosPONAL INTO @idEmpresa, @unidadPadre, @nombreArea, @nombreCargo, @descripcionCargo
		WHILE @@FETCH_STATUS = 0 BEGIN
			BEGIN TRANSACTION
				IF NOT EXISTS (
				SELECT	*
					FROM	Cargo
					WHERE	UPPER(LTRIM(RTRIM(nombreCargo))) = UPPER(LTRIM(RTRIM(@nombreCargo)))
					AND UPPER(LTRIM(RTRIM(descripcionCargo))) = UPPER(LTRIM(RTRIM(@descripcionCargo)))
				
				) BEGIN
					SELECT @idArea = idArea from AreaOrganizacional WHERE nombreArea = @unidadPadre
					-- Insertando registro
					INSERT INTO	Cargo (idEmpresa, idArea, nombreCargo, descripcionCargo, codigo)
						VALUES (@idEmpresa, @idArea, @nombreCargo, @descripcionCargo, NULL)
				END
			COMMIT TRANSACTION
			FETCH NEXT FROM curCargosPONAL INTO @idEmpresa, @unidadPadre, @nombreArea, @nombreCargo, @descripcionCargo
		END
END
GO


CREATE PROCEDURE [dbo].[sp_SincronizarFuncionario] AS

DECLARE		@idEmpresa			INT,
			@idCargo			INT,
			@nombreFuncionario	VARCHAR(50),
			@nombreCargo		VARCHAR(50)
									
	BEGIN
	DECLARE	curFuncionariosPONAL CURSOR LOCAL FOR
	--
	--  Sincronizacin de Funcionarios de la empresa hacia Funcionarios de AudiRisk
	--	Extraer la informacin de la vista y asignarla directamente en la consulta OPENQUERY
	--
		SELECT	IDEMPRESA, NOMBRE_FUNCIONARIO, NOMBRE_CARGO
			FROM OPENQUERY(PONAL_VISTAS,'select * from USR_REHU.V_FUNCIONARIOS_AUDIRISK')
	
	OPEN curFuncionariosPONAL
		FETCH NEXT FROM curFuncionariosPONAL INTO @idEmpresa, @nombreFuncionario, @nombreCargo
		WHILE @@FETCH_STATUS = 0 BEGIN
			BEGIN TRANSACTION
				IF NOT EXISTS (
				SELECT	*
					FROM	Funcionario
					WHERE	UPPER(LTRIM(RTRIM(nombreFuncionario))) = UPPER(LTRIM(RTRIM(@nombreFuncionario)))
				) BEGIN
					SELECT @idCargo = idCargo from Cargo WHERE nombreCargo = @nombreCargo
					-- Insertando registro
					INSERT INTO	Funcionario(idCargo, nombreFuncionario, idEmpresa, codigo)
						VALUES (@idCargo, @nombreFuncionario, @idEmpresa, NULL)
				END
			COMMIT TRANSACTION
			FETCH NEXT FROM curFuncionariosPONAL INTO @idEmpresa, @nombreFuncionario, @nombreCargo
		END
END
GO

------------------------------------------------------------------------------------------
-- Fin Script 10 Abril 2015 Oscar Garcia	                  	                        --
------------------------------------------------------------------------------------------